nnew = 1
strue = 2
sims = 10000

for(n in c(10,20,100)){
for(m in 2:5){
print(paste0("m=",m," n=",n," nnew=",nnew," sims=",sims," strue=",strue))
res = data.frame()
stdobss = data.frame()

for(i in 1:sims){

set.seed(n*1000000+i*100)
  
d = data.frame(id = rep(1:n,each=m))
d$rep = rep(1:m,times=n)
d$g = rep(runif(n,0,10),each=m)
d$e = rnorm(n*m,0,strue)
d$x = d$g + d$e

dnew = data.frame(id = rep(1:nnew,each=m) )
dnew$rep = rep(1:m,times=nnew)
dnew$g = rep(runif(nnew,0,10),each=m)
dnew$e = rnorm(nnew*m,0,strue)
dnew$x = dnew$g + dnew$e

dw = reshape(d[,c("id","rep","x")],idvar="id",timevar="rep",direction="wide")[,2:(m+1)]
dneww = reshape(dnew[,c("id","rep","x")],idvar="id",timevar="rep",direction="wide")[,2:(m+1)]

dw$d = dw[,1]-dw[,2]
dw$s = apply(dw[,1:m],1,sd)
dw$m = apply(dw[,1:m],1,mean)

dneww$s = apply(dneww[,1:m],1,sd)
dneww$m = apply(dneww[,1:m],1,mean)

means=sqrt(mean(dw$s^2))
lim=sqrt(qchisq(0.95,m-1))*sqrt(m-1)/(m-1)*means

res = rbind(res,data.frame(count=mean(ifelse(dw$s<lim,1,0)),countnew=mean(ifelse(dneww$s<lim,1,0)),means=means,lim=lim))
stdobss = rbind(stdobss,data.frame(mds=dw$s/means,mdnews=dneww$s/means))
}
print(mean(res$count))
print(mean(res$countnew))
print(quantile(stdobss$mds,prob=0.95))
print(quantile(stdobss$mdnews,prob=0.95))
}
}
